package com.android.td5;

import android.os.Handler;
import android.os.Looper;

public class SieveModel {
	// Maximum number of threads in the pool
	public static final int MAX_THREADS = 4;

	// Maximum sieve upper bound
	public static final int MAX_NUMBER = 1000000;

	SieveModel(Sieve sieve) {
		this.sieve = sieve;
	}

	private Sieve sieve;
	
	// Sieve upper bound
	private int number;

	// Array to mark prime numbers
	private boolean isPrime[];
	
	// Shared variable holding the number of prime integers found
	private int primes;

	// Marking delay, initially set to 0 (Fastest)
	private int delay = 0;

	// Number of marker threads
	private int numThreads = 1;

	private void printStatus(String s) {
		sieve.printStatus(s);
	}

	private void printResult(String s) {
		sieve.printResult(s);
	}

	private void countAndPrint() {
		primes = 0;

		// To be completed
		
		printResult("There are " + primes + " prime number"
				+ (primes != 1 ? "s" : "") + " until " + number);
		printStatus("Sieve completed");
	}

	// Invalidate ongoing operations
	public void abortSieve() {
		number = 0;
	}

	public int getNumber() {
		return number;
	}
	
	public void setNumber(int number) {
		this.number = number;
	}
	
	public boolean[] getIsPrime() {
		return isPrime;
	}
	
	public void setIsPrime(boolean[] isPrime) {
		this.isPrime = isPrime;
	}

	// Get the sleep delay for marker thread animations
	public int getDelay() {
		return delay;
	}

	// Update the sleep delay for marker thread animations
	public void setDelay(int delay) {
		this.delay = delay;
	}
	
	// Get the number of Marker threads
	public int getNumThreads() {
		return numThreads;
	}
	
	// Set the number of Marker threads
	public void setNumThreads(int t) {
		abortSieve();
		
		if (t < 1)
			t = 1;
		if (t > MAX_THREADS)
			t = MAX_THREADS;
		
		numThreads = t;
	}

	// Compute the sieve of Eratosthenes
	public void sieve() {
		primes = 0; 
		printResult("");
		
		number = sieve.parseNumber();

		// To be completed
	}
}
